package com.timzaak.ucloud.iot.model;

import cn.ucloud.common.annotation.UcloudParam;
import cn.ucloud.common.pojo.BaseRequestParam;

import javax.validation.constraints.NotEmpty;

public class PublishMessage extends BaseRequestParam {

    @NotEmpty(message = "region can not be empty")
    @UcloudParam("Region")
    private String region;

    @NotEmpty(message = "productSN can not be empty")
    @UcloudParam("ProductSN")
    private String productSN;

    @UcloudParam("TopicFullName")
    private String topicName;


    @UcloudParam("MessageContent")
    private String messageContent;

    @UcloudParam("Qos")
    private int qos = 0;


    public PublishMessage(String region, String productSN, String topicName) {
        super("PublishUIoTCoreMQTTMessageResponse");
        this.region = region;
        this.productSN = productSN;
        this.topicName = topicName;
    }

    public String getRegion() {
        return region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public String getProductSN() {
        return productSN;
    }

    public void setProductSN(String productSN) {
        this.productSN = productSN;
    }

    public String getTopicName() {
        return topicName;
    }

    public void setTopicName(String topicName) {
        this.topicName = topicName;
    }

    public int getQos() {
        return qos;
    }

    public void setQos(int qos) {
        this.qos = qos;
    }

    public String getMessageContent() {
        return messageContent;
    }

    public void setMessageContent(String messageContent) {
        this.messageContent = messageContent;
    }
}
