package com.timzaak.ucloud.iot.model;

import cn.ucloud.common.annotation.UcloudParam;
import cn.ucloud.common.pojo.BaseRequestParam;

import javax.validation.constraints.NotEmpty;

public class SendDeviceCommandRequest extends BaseRequestParam {
    @NotEmpty(message = "region can not be empty")
    @UcloudParam("Region")
    private String region;

    @NotEmpty(message = "productSN can not be empty")
    @UcloudParam("ProductSN")
    private String productSN;

    @NotEmpty(message = "deviceSN can not be empty")
    @UcloudParam("DeviceSN")
    private String deviceSN;

    @UcloudParam("Identifier")
    private String identifier;

    @UcloudParam("Input")
    private String input;

    @UcloudParam("Method")
    private String method;

    @UcloudParam("Timeout")
    private Integer timeout;

    public SendDeviceCommandRequest() {
        super("SendUIoTCoreDeviceCommand");
    }

    public String getRegion() {
        return region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public String getProductSN() {
        return productSN;
    }

    public void setProductSN(String productSN) {
        this.productSN = productSN;
    }

    public String getDeviceSN() {
        return deviceSN;
    }

    public void setDeviceSN(String deviceSN) {
        this.deviceSN = deviceSN;
    }

    public String getIdentifier() {
        return identifier;
    }

    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }

    public String getInput() {
        return input;
    }

    public void setInput(String input) {
        this.input = input;
    }

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }

    public Integer getTimeout() {
        return timeout;
    }

    public void setTimeout(Integer timeout) {
        this.timeout = timeout;
    }
}
