package com.timzaak.ucloud.iot.model;

import cn.ucloud.common.annotation.UcloudParam;
import cn.ucloud.common.pojo.BaseRequestParam;

import javax.validation.constraints.NotEmpty;

public class SetDevicePropertyRequest extends BaseRequestParam {

    @NotEmpty(message = "region can not be empty")
    @UcloudParam("Region")
    private String region;

    @NotEmpty(message = "productSN can not be empty")
    @UcloudParam("ProductSN")
    private String productSN;

    @NotEmpty(message = "deviceSN can not be empty")
    @UcloudParam("DeviceSN")
    private String deviceSN;

    @UcloudParam("Property")
    private String property;

    @UcloudParam("Desired")
    private boolean desired;


    public SetDevicePropertyRequest() {
        super("SetUIoTCoreDeviceProperty");
    }

    public String getRegion() {
        return region;
    }

    public void setRegion(String region) {
        this.region = region;
    }

    public String getProductSN() {
        return productSN;
    }

    public void setProductSN(String productSN) {
        this.productSN = productSN;
    }

    public String getDeviceSN() {
        return deviceSN;
    }

    public void setDeviceSN(String deviceSN) {
        this.deviceSN = deviceSN;
    }

    public String getProperty() {
        return property;
    }

    public void setProperty(String property) {
        this.property = property;
    }

    public boolean isDesired() {
        return desired;
    }

    public void setDesired(boolean desired) {
        this.desired = desired;
    }
}
