package com.mjitech.api

import com.timzaak.ktor.params
import io.ktor.http.plus

class SkuAPI(private val baseAPIImpl: BaseAPIImpl) : API by baseAPIImpl {

    suspend fun notifySKUMiss(outBatchId: Int, outBatchSkuId: Int, orderNumber: String): Result<Pair<Boolean, NotifySKUMissResponse>> {
        val data = params(
            "outBatchId" to outBatchId.toString(),
            "outBatchSkuId" to outBatchSkuId.toString(),
            "orderNumber" to orderNumber
        )
        return post("/machine_api/fail_get_sku.action", data).resultWithB()
    }

    suspend fun changeSku(
        skuId: Int,
        outBatchSkuId: Int
    ): Result<Unit> {

        val url = "/machine_api/set_outbatchsku_status.action"
        val data = params(
            "skuId" to skuId.toString(),
            "outBatchSkuId" to outBatchSkuId.toString()
        )
        return post(url, data).result()
    }

    suspend fun setOutBatchSkuStatus(
        batchId: Int,
        outBatchSkuId: Int,
        orderNumber: String,
        skuStatus: Int
    ): Result<Unit> {

        val url = "/machine_api/set_outbatchsku_status.action"
        val data = params(
            "outBatchId" to batchId.toString(),
            "outBatchSkuId" to outBatchSkuId.toString(),
            "orderNumber" to orderNumber,
            "status" to skuStatus.toString()
        )
        return post(url, data).result()
    }
}
