package com.mjitech.bash

import com.mjitech.iot.IotClient
import com.timzaak.jackson.KtorJacksonWrapper
import com.timzaak.ucloud.iot.UIotServerClient
import com.typesafe.config.ConfigFactory
import mu.KotlinLogging
import java.io.BufferedReader
import java.io.File
import java.io.FileReader

class AddDevice {
    private val logger = KotlinLogging.logger { }
    val config = ConfigFactory.load()
    val objectMapper = KtorJacksonWrapper.jacksonMapper

    val c = config.getConfig("api.mqttServer")
    val uIotServerClient = UIotServerClient(
            c.getString("privateKey"),
            c.getString("publicKey"),
            config.getString("api.mqtt.productSN")
    )
    val iotClient = IotClient(uIotServerClient,objectMapper)

    fun run(deviceSN: String , storeId: String) {

        val message = iotClient.addDevice(deviceSN,storeId)
        if (message == null) {
            logger.warn { "add device error deviceSN:$deviceSN, storeId:$storeId" }
        } else {
            logger.info { "product application.config deviceSN:$deviceSN, storeId:$storeId" }
            productConfigFile(storeId,deviceSN,message.password)
        }

    }

    /**
     * 读TXT文件内容
     * @param filePath 文件路径(不要以 / 结尾)
     * @param fileName 文件名称（包含后缀,如：ReadMe.txt）
     * @return
     */
    @Throws(Exception::class)
    fun add(filePath: String, fileName: String) {
        val file = File("$filePath/$fileName")
        var fileReader: FileReader? = null
        var bufferedReader: BufferedReader? = null
        try {
            fileReader = FileReader(file)
            bufferedReader = BufferedReader(fileReader)
            try {
                var read: String? = null
                while ({ read = bufferedReader.readLine();read }() != null) {
                        val info = read!!.split(",")
                        this.run(info.get(0),info.get(1))
                }
            } catch (e: Exception) {
                e.printStackTrace()
            }

        } catch (e: Exception) {
            e.printStackTrace()
        } finally {
            if (bufferedReader != null) {
                bufferedReader.close()
            }
            if (fileReader != null) {
                fileReader.close()
            }
        }
    }
}




fun main() {
    val r = AddDevice()
    r.add("Devices.txt","")
}

