package com.mjitech.bash

import com.atlassian.performance.tools.ssh.api.Ssh
import com.atlassian.performance.tools.ssh.api.SshHost
import com.atlassian.performance.tools.ssh.api.auth.PasswordAuthentication
import com.github.salomonbrys.kotson.get
import com.mjitech.iot.DeviceStatus
import com.mjitech.iot.IotClient
import com.timzaak.jackson.KtorJacksonWrapper
import com.timzaak.ucloud.iot.UIotServerClient
import com.typesafe.config.ConfigFactory
import kotlinx.coroutines.delay
import mu.KotlinLogging
import java.io.File
import java.time.Duration

val logger = KotlinLogging.logger{}
class InitMachine {
    val objectMapper = KtorJacksonWrapper.jacksonMapper
    fun run(storeId: String , imageVersion: String ,ssh:SshContent ) {
        val sshHost = SshHost(ssh.IpAddress, ssh.UserName, PasswordAuthentication(ssh.Password),22)
        Ssh(sshHost).newConnection().use { ssh ->
            val confFile = File("configfile/application.$storeId.conf")
            ssh.upload(confFile,"/home/mjitech/server/")
//            ssh.execute("docker login uhub.service.ucloud.cn -u timzaakzhang@mjitech.com -p 52wUZq22")
            val resultPull = ssh.execute("docker pull uhub.service.ucloud.cn/mjitech/upper:"+imageVersion, Duration.ofSeconds(999))
            if(resultPull.isSuccessful()){
                val resultRun = ssh.execute("docker run -it --privileged --name upp -v /home/mjitech/server/application.$storeId.conf:/app/application.conf --restart=always -v /var/run/docker.sock:/var/run/docker.sock --network=host -d uhub.service.ucloud.cn/mjitech/upper:"+imageVersion)
                if(resultRun.isSuccessful()){
                    log.info { "upper init success" }
                    log.info(ssh.execute("docker ps").output)
                }else{
                    log.info { "run fail" }
                }
            }else{
                log.info { "pull fail" }
            }
        }
    }
}

fun main() {
    val r = InitMachine()
        r.run(
                "97",
                "latest",
                SshContent("10.243.227.147","mjitech","mjitech123")
    )
}

