package com.mjitech.bash

import com.github.salomonbrys.kotson.get
import com.mjitech.iot.DeviceStatus
import com.mjitech.iot.IotClient
import com.timzaak.jackson.KtorJacksonWrapper
import com.timzaak.ucloud.iot.UIotServerClient
import com.typesafe.config.ConfigFactory

class ReloadBrowser {
    val config = ConfigFactory.load()
    val objectMapper = KtorJacksonWrapper.jacksonMapper
    fun run(productSN: String , deviceSN: String  ) {
        val c = config.getConfig("api.mqttServer")
        val uIotServerClient = UIotServerClient(
                c.getString("privateKey"),
                c.getString("publicKey"),
                productSN
        )
        val iotClient = IotClient(uIotServerClient,objectMapper)
        val result = iotClient.getDeviceInfo(deviceSN)
        when(result.property.get("state").get("Value").asInt){
            DeviceStatus.Free -> {
                println("state:free")
                iotClient.reloadBrowser(deviceSN)
            }
            else ->{
                this.run(productSN,deviceSN)
            }
        }
        if (result == null) {
            println("send message error")
        } else {
            val msg = result.property.get("state")
            println("send message result: $msg")
        }
    }
}

fun main() {
    val r = ReloadBrowser()
        r.run(
            ConfigFactory.load().getString("api.mqtt.productSN"),
            "6utc8rmzb1c57hm8"
    )
}

