package com.mjitech.compatible

import com.mjitech.service.state.WebResponseCache
import com.mjitech.service.state.entity.State

/*
    MACHINE_FREE:0,x
    ERROR_QR:1,x
    ERROR_STORE:2,x
    TAKING_SUCC:3,
    TAKING_FAIL:4,
    ERROR_MACHINE:5,
    OPEN_DOOR:6, // push pad + open door
    OPENING_DOOR:7,
    CLOSE_DOOR:8,
    PRODUCT_REMAIN:9,
    UPDATE_SKU_DATA:800,
    UPDATE_MACHINE_PC:900,
    UPDATE_MACHINE_SCM:901,
    REPAIR:902,x
    FILL_GOODS:903,
    OTHER_PLEASE_WAIT:999,
    FINISH_UPDATE:904,x
 */
// TODO: don't finish
fun <T : State> T.statusIdAdapt(cacheData: WebResponseCache.CacheData): Int {
    if (cacheData.needReload) {
        return 904
    }
    if (cacheData.errorOrderInfo != null) {
        return 2
    }
    return when (this) {
        is State.Init -> 999 // 老的没有 初始化说法
        is State.Free -> 0
        is State.DoBusiness.TakingGood -> {
            // 有失败的 -4, 没有 。3
            if (this.errorStep != -1) {
                4
            } else {
                3
            }
        }
        is State.DoBusiness.OpenGoodDoor -> {
            if (this.isOpening) {
                7
            } else {
                6
            }
        }
        is State.Inspection.Repair -> 902
        is State.Inspection.Update -> 902
        is State.Inspection.OpenDoor -> 903
        is State.MachineError.TakeGoodError -> 5
        is State.Inspection.UpdateMachinePc -> 900
        is State.MachineError.DownMachineLost -> 5
        is State.MachineError.MachineIsNotSafe -> 5
        else -> -1
    }
}
/*
fun <T:State> T.isWorking() :Boolean{
    return when(this) {
        is State.Free -> true
        else -> {
            false
        }
    }
}

 */
