package com.mjitech.model

import com.mjitech.api.model.SKU
//TODO: need to delete
data class Order(
    val orderNumber: String,
    val id: Int,
    var skus: List<SKU>
) {
    val takeTimes: Int by lazy {
        skus.sumBy { it.count }
    }
    companion object {
        fun fromOrder(apiOrder: com.mjitech.api.model.Order): Order {
            val skus = apiOrder.batches.flatMap {

                it.skus.flatMap { sku ->

                    val count = sku.count
                    if (count == 1) {
                        listOf(sku)
                    } else {
                        val newSku = sku.copy(count = 1)
                        List(count) { newSku }
                    }
                }
                it.skus
            }.sortedWith(object : Comparator<SKU> {
                override fun compare(o1: SKU, o2: SKU): Int {
                    if (o1.isPresent && !o2.isPresent) {
                        return 1
                    } else if (o2.isPresent && !o1.isPresent) {
                        return -1
                    }
                    return 0
                }
            })
            return Order(
                orderNumber = apiOrder.orderNumber,
                id = apiOrder.id,
                skus = skus
            )
        }
    }
    fun replaceSku(outBatchSkuIds: List<Int>): Order {
        // skus[index] = sku
        // return this.copy(skus = skus.filterIndexed { index, sku -> index != i })
        for (id in outBatchSkuIds) {
            skus.filterIndexed { _, oldsku -> oldsku.outBatchSkuId != id }
        }
        return this.copy(skus = skus)
    }

    fun updateSku(sku: SKU, step: Int): Order {
        if (step == 0) {
            skus = listOf(sku) + skus.filterIndexed { index, _ -> index != step }
        } else {
            skus = skus.subList(0, step) + listOf(sku) + skus.subList(step+1, skus.size)
        }
        return this.copy(skus = skus)
    }

    fun getSKUByStep(step: Int): SKU? {
        var index = 0
        for (sku in skus) {
            if (index == step) {
                return sku
            }
            index += 1
        }
        return null
    }
}
