package com.mjitech.service

import com.mjitech.service.state.StateTransition
import com.mjitech.service.state.entity.SideEffect
import com.mjitech.service.state.entity.State
import com.timzaak.jackson.jsObject
import com.timzaak.ws.ConnectionManager
import io.ktor.http.cio.websocket.Frame
import kotlin.coroutines.CoroutineContext

//TODO: 老的SB逻辑，导致的这个没有用处
class RepairService(
    private val connectionManager: ConnectionManager,
    override val coroutineContext: CoroutineContext
) : Service {

    /*
    init {
        launch {
            loop()
        }
    }

    private suspend fun loop() {
        // 平板链接过程中要被轮询发消息
        while (true) {
            delay(2000)
            stateManager.downMachineState?.let {
                connectionManager.broadcastAll(
                    Frame.Text(it.toAttachmentAdapt().toString())
                )
            }
        }
    }
*/

    override suspend fun consume(transition: StateTransition) {
        transition.sideEffect?.let { sideEffect ->
            when (sideEffect) {
                is SideEffect.OpenDoorInRepair -> {
                    // 兼容老的服务, need remove
                    when (sideEffect.doorId) {
                        State.Inspection.OpenDoor.ADoor -> "A"
                        State.Inspection.OpenDoor.BDoor -> "B"
                        else -> null
                    }?.let {
                        connectionManager.broadcastAll(
                            Frame.Text(
                                jsObject {
                                    "type" /= "SUCCESS_OPENDOOR"
                                    "info" /= jsObject {
                                        "area" /= it
                                    }
                                }.toString()
                            )
                        )
                    }
                }
                else -> {
                }
            }
        }
    }
}
