package com.mjitech.service.state

import com.timzaak.ucloud.mqtt.entity.PropertyValue


// TODO: 不确定，为什么老代码关于 isSafe 的判定 会和门状态上报有不同之处。
data class DoorState(
    val aDoorIsSafe: Boolean = true,
    val bDoorIsSafe: Boolean = true,
    val electronDoorIsSafe: Boolean = true
) {
    companion object {
        fun getDefaultForMqtt(): Map<String, PropertyValue<Int>> {
            return mapOf(
                "aDoor" to PropertyValue(1),
                "bDoor" to PropertyValue(1),
                "electronDoor" to PropertyValue(1)
            )
        }
    }

    fun getDiffMapForMqtt(newDoorState: DoorState): Map<String, PropertyValue<Int>> {
        val map = emptyMap<String, PropertyValue<Int>>().toMutableMap()
        if (aDoorIsSafe != newDoorState.aDoorIsSafe) {
            map += "aDoor" to PropertyValue(newDoorState.aDoorIsSafe.toInt())
        }
        if (bDoorIsSafe != newDoorState.bDoorIsSafe) {
            map += "bDoor" to PropertyValue(newDoorState.bDoorIsSafe.toInt())
        }
        if (electronDoorIsSafe != newDoorState.electronDoorIsSafe) {
            map += "electronDoor" to PropertyValue(newDoorState.electronDoorIsSafe.toInt())
        }
        return map
    }

}

private fun Boolean.toInt(): Int {
    return if (this) 1 else 0
}