package com.mjitech.service.state.entity

import com.mjitech.api.model.Order

sealed class SideEffect {
    data class TakeBatch(val order: Order,val batchStep:Int, val step: Int) : SideEffect()
    data class TakeGood(val order: Order, val batchStep:Int, val step: Int, val errorstep: Int = -1) : SideEffect()
    data class OpenDoor(val order: Order, val batchStep: Int) : SideEffect()
    data class SetStatusTaking(val order: Order,val batchStep: Int, val step: Int) : SideEffect()
    data class TakeGoodFailure(val order: Order, val batchStep: Int,val failureStep: Int) : SideEffect()
    data class ChangeSku(val order: Order, val batchStep: Int, val step: Int) : SideEffect()
    data class MachineError(val order: Order, val batchStep: Int, val step: Int, val failureStep: Int) : SideEffect()
    data class TestTakingSku(val shelfNumber: Int, val x: Int, val y: Int, val x1: Int, val y1: Int) : SideEffect()

    data class TestDownMachineLost(val isLost:Boolean) : SideEffect()

    object EnterRepair : SideEffect()
    data class OpenDoorInRepair(val doorId: Int) : SideEffect()
    object BackToFree : SideEffect()
    // data class ReloadScreen()
}
