package com.mjitech.third.down.entity

import com.mjitech.third.down.protocol.DownDecoder
import com.mjitech.third.down.protocol.DownEncoder
import kotlinx.serialization.KSerializer

interface Command {
    fun toBytes(): Pair<Int, ByteArray>
}

interface CommandResponse : Command
interface CommandRequest : Command

interface CommandDesc {
    val type: Byte
}

fun <T : Command> KSerializer<T>.toBytes(v: T, type: Byte): Pair<Int, ByteArray> {
    val e = DownEncoder(type)
    serialize(e, v)
    return e.getFrameNumber() to e.getData()
}

fun <T : Command> KSerializer<T>.toCommand(array: ByteArray): T {
    val d = DownDecoder(array)
    return deserialize(d)
}
