package com.mjitech.third.down.entity.server

import com.mjitech.third.down.entity.CommandDesc
import com.mjitech.third.down.entity.CommandResponse
import com.mjitech.third.down.entity.toBytes
import kotlinx.serialization.Serializable
import kotlin.experimental.or

@Serializable
data class HeartBeatResponse(
    val fuckWhat: Byte,
    val leftHorseBlock: Byte, // 左踏台
    val rightHorseBlock: Byte,
    val replenishmentScreen: Byte, // 补货屏
    val leftDoor: Byte, // 左柜门
    val rightDoor: Byte,
    val electronDoor: Byte, // 电柜门
    val sealPort: Byte, // 密封口
    val shipmentWarehouse: Byte, // 出货仓
    val innerDoor: Byte // 货仓内部关门
) : CommandResponse {

//    safeSts[0],左踏台，0不安全 1安全
//    safeSts[1],右踏台，0不安全 1安全
//    safeSts[2],补货屏，0不安全 1安全
//    safeSts[3],左柜门，0打开 1关闭
//    safeSts[4],右柜门，0打开 1关闭
//    safeSts[5],电柜门，0打开 1关闭
//    safeSts[6],密封口，0负限位 1正限位
//    safeSts[7],出货仓，0负限位 1正限位
//    safeSts[8],货仓内部关门，0负限位1正限位

    override fun toBytes(): Pair<Int, ByteArray> {
        return serializer().toBytes(
            this,
            type
        )
    }

    fun isSafe(): Boolean {
        val result =
            (leftHorseBlock or rightHorseBlock or replenishmentScreen).toInt()
        return result == 1.toByte().toInt()
    }

    companion object : CommandDesc {
        const val Safe = 1.toByte()
        override val type: Byte = 0x09.toByte()
        fun fromACKResponse(v: ACKResponse): HeartBeatResponse {
            return HeartBeatResponse(
                0.toByte(),
                v.leftHorseBlock,
                v.rightHorseBlock,
                v.replenishmentScreen,
                v.leftDoor,
                v.rightDoor,
                v.electronDoor,
                v.sealPort,
                v.shipmentWarehouse,
                v.innerDoor
            )
        }
    }
}
