package com.mjitech.third.down.entity.server

import com.mjitech.third.down.entity.CommandDesc
import com.mjitech.third.down.entity.CommandResponse
import com.mjitech.third.down.entity.toBytes
import kotlinx.serialization.Serializable

@Serializable
data class OutGoodDoorStatus(
    val status: Byte
) : CommandResponse {
    companion object : CommandDesc {
        override val type: Byte = 0x14.toByte()

        const val opening: Byte = 1.toByte()
        const val openSuccess: Byte = 2.toByte()
        const val openFailure: Byte = 3.toByte()
    }

    override fun toBytes(): Pair<Int, ByteArray> {
        return serializer().toBytes(this, type)
    }
}
