package com.mjitech.third.down.entity.server

import com.mjitech.third.down.entity.CommandDesc
import com.mjitech.third.down.entity.CommandResponse
import com.mjitech.third.down.entity.toBytes
import kotlinx.serialization.Serializable

@Serializable
data class OutGoodStatus(
    // val type:Byte,
    val originalFrameNumber: Int,
    val outGoodNumber: Byte, // 出货编号 -> ShelfNumber
    val status: Byte, // 出货状态
    val takingWhich: Byte
) : CommandResponse {

    override fun toBytes(): Pair<Int, ByteArray> {
        return serializer().toBytes(
            this,
            type
        )
    }

    companion object : CommandDesc {
        override val type: Byte = 0x0d.toByte()

        object Status {
            //    0：闲置状态
//    1：正在出货
//    2：每个商品到出货口(未开取货门)
//    3：用户正在取货(取货门打开)
//    4：取货有遗漏
//    5：取货无遗漏
//    6：取货完成，舱门关闭
//    7：售卖动作完成，可以开始下次售卖。
//    8：单件商品取出完成（机械手已复位）
//    9：取货失败。
//    10：设备故障。
//    11：该批次已完成抓取，等待出货
            val FreeStatus = 0.toByte()
            val IS_TAKING = 1.toByte() // need
            val GoodNearDoor = 2.toByte()
            val DoorIsOpen = 3.toByte()
            val PRODUCT_REMAIN = 4.toByte() // need
            val TakingGoodOk = 5.toByte()
            val CloseDoor = 6.toByte() // need
            val READY = 7.toByte() // need
            val TakeSingleGood = 8.toByte() // need
            val TakeGoodMiss = 9.toByte() // need
            val MachineError = 10.toByte() // need
            val TakeBatchGoodFinish = 11.toByte()
        }
    }
}
