package com.mjitech.third.down.mock

import com.mjitech.third.down.entity.CommandResponse
import com.mjitech.third.down.entity.HeartBeatRequest
import com.mjitech.third.down.entity.OutGoodDoor
import com.mjitech.third.down.entity.OutGoods
import com.mjitech.third.down.entity.server.HeartBeatResponse
import com.mjitech.third.down.entity.server.OutGoodDoorStatus
import com.mjitech.third.down.entity.server.OutGoodStatus
import com.mjitech.third.down.entity.toCommand
import com.mjitech.third.down.protocol.getFrameNumber
import com.mjitech.third.down.protocol.getFrameType
import com.mjitech.third.down.protocol.toHumanRead
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import mu.KLogger

// 串口逻辑，改成 udp 逻辑
interface MockDownServer : CoroutineScope {
    val logger: KLogger
    fun sendCommand(command: CommandResponse)


    fun listen(data: ByteArray,heartBeatResponse: HeartBeatResponse) {
//        logger.debug { "receive command from client:${data.toHumanRead()}" }

        when (data.getFrameType()) {
            HeartBeatRequest.type -> {
                sendCommand(
                        heartBeatResponse
                )
            }
            OutGoods.type -> {
                logger.info { "outGoods response" }
//                val command = OutGoods.serializer().toCommand(data)
                //取货成功
                val takeSuccess = listOf(1.toByte(),8.toByte(),1.toByte(),8.toByte(),1.toByte(),8.toByte(),1.toByte(),8.toByte())
                //取货失败
                val takeFail = listOf(1.toByte(),8.toByte(),1.toByte(),8.toByte(),1.toByte(),9.toByte(),1.toByte(),8.toByte())
                var index = 0
                //是否成功取货
                var status = 1
                launch {
                        if((0..10).random()>3){
                        while (index < 8) {
                            logger.info { "takeGood receive command ${takeSuccess[index]}" }
                            sendCommand(
                                    OutGoodStatus(
                                            data.getFrameNumber(),
                                            1.toByte(),
                                            takeSuccess[index],
                                            2
                                    )
                            )
                            index++
                            delay(1000)
                        }
                    }else{
                        while (index < 8) {
                            logger.info { "takeGood receive command ${takeFail[index]}" }
                            sendCommand(
                                    OutGoodStatus(
                                            data.getFrameNumber(),
                                            1.toByte(),
                                            takeFail[index],
                                            2
                                    )
                            )
                            index++
                            delay(1000)
                        }
                    }
                }
//                sendCommand(
//                    (
//                        data.getFrameNumber(),
//                        data.getFrameType(),
//                        1,
//                        0
//                    )
//                )
            }
            OutGoodDoor.type -> {
                sendCommand(
                    OutGoodDoorStatus(
                        OutGoodDoorStatus.openSuccess
                    )
                )
                launch {
                    delay(1000)
                    sendCommand(
                            OutGoodStatus(
                                    data.getFrameNumber(),
                                    1.toByte(),
                                    7.toByte(),
                                    1
                            )
                    )
                }

            }
            else -> {
            }
        }
//        sendCommand(ACK(
//            data.getFrameNumber(),
//            data.getFrameType(),
//            1,
//            0
//        ))
    }
}
