package com.mjitech.third.down.mock.entity

import com.mjitech.third.down.entity.server.HeartBeatResponse

data class HeartBeatState(
        var aDoorIsClose: Boolean = true,
        var bDoorIsClose: Boolean = true,
        var electronDoorIsClose: Boolean = true,
        var replenishmentScreenIsSafe: Boolean = true
){
    companion object {
        fun getDefaultForMock(): HeartBeatResponse {
            return HeartBeatResponse(
                    0.toByte(),
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe,
                    HeartBeatResponse.Safe
            )
        }
    }

    fun getHeartBeatState(): HeartBeatResponse{
        return HeartBeatResponse(
                0.toByte(),
                HeartBeatResponse.Safe,
                HeartBeatResponse.Safe,
                replenishmentScreenIsSafe.toByte(),
                aDoorIsClose.toByte(),
                bDoorIsClose.toByte(),
                electronDoorIsClose.toByte(),
                HeartBeatResponse.Safe,
                HeartBeatResponse.Safe,
                HeartBeatResponse.Safe
        )
    }

    fun setHeartBeatState(heartBeatState: HeartBeatState){
        this.aDoorIsClose = heartBeatState.aDoorIsClose
        this.bDoorIsClose = heartBeatState.bDoorIsClose
        this.electronDoorIsClose = heartBeatState.electronDoorIsClose
        this.replenishmentScreenIsSafe = heartBeatState.replenishmentScreenIsSafe
    }


}

private fun Boolean.toByte(): Byte {
    return if (this) 1.toByte() else 0.toByte()
}