package com.mjitech.third.scancode.mock

import com.fazecast.jSerialComm.SerialPort
import com.mjitech.third.down.protocol.connectionOptions
import com.mjitech.third.scancode.Delimiter
import com.mjitech.third.scancode.MessagePrefix
import mu.KotlinLogging

class MockScanCodeServer(portDescriptor: String) {
    private val logger = KotlinLogging.logger {}
    private val port: SerialPort = SerialPort.getCommPort(portDescriptor)

    init {
        connectionOptions(port)
        port.openPort()
        logger.debug("Mock Scan Code Server init...port:$portDescriptor")
    }

    fun sendMessage(message: String) {
//        val m = "${MessagePrefix}${message}$Delimiter".toByteArray()
        val m = "${MessagePrefix}${message}$Delimiter".toByteArray()
        logger.debug { "send message" }
        port.writeBytes(m, m.size.toLong())
    }

    fun close(){
        port.closePort()
    }
}
