package com.timzaak.coroutines.channel

import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.channels.BroadcastChannel
import kotlin.coroutines.CoroutineContext

interface ScopeBroadcastChannel<T> : CoroutineScope {
    val channel: BroadcastChannel<T>
    suspend fun send(message: T)
}

class BaseScopeBroadcastChannel<T>(
    capacity: Int,
    override val coroutineContext: CoroutineContext
) : ScopeBroadcastChannel<T> {
    override val channel: BroadcastChannel<T> = BroadcastChannel(capacity)
    override suspend fun send(message: T) {
        channel.send(message)
    }
}
