package com.timzaak.coroutines.channel

import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.launch
import kotlin.coroutines.CoroutineContext

interface ScopeChannel<T> {
    fun send(message: T)
    val channel: Channel<T>
}

class BaseScopeChannel<T>(override val coroutineContext: CoroutineContext) : ScopeChannel<T>, CoroutineScope {
    override val channel = Channel<T>()
    override fun send(message: T) {
        launch {
            channel.send(message)
        }
    }
}
