package com.timzaak.docker

import com.amihaiemil.docker.LocalDocker
import com.typesafe.config.ConfigFactory
import mu.KotlinLogging
import java.io.File
import javax.json.JsonObject

interface DockerClient {
    fun getContainerList(): List<String>
    fun restartContainer()
}
class DockerClientImp:DockerClient {
    private val logger = KotlinLogging.logger { }
    override fun getContainerList(): List<String> {
        try {
            val docker = LocalDocker(File("/var/run/docker.sock"))
            return docker.containers().map {
                logger.info { "Image:${(it.inspect()["Config"] as JsonObject).getString("Image")}" }
                (it.inspect()["Config"] as JsonObject).getString("Image")
            }
        } catch (e: Throwable) {
            logger.error(e) { "get docker image list error" }
            return listOf()
        }
    }
    override fun restartContainer() {
        val docker = LocalDocker(File("/var/run/docker.sock"))
        if (System.getProperty("os.name").toLowerCase().indexOf("win") < 0) {
            docker.containers().map {
                it.restart()
            }
        }else {
            logger.info { "docker client: restart container" }
        }


    }
}
