package com.timzaak.net

import java.net.Inet4Address
import java.net.NetworkInterface

class LocalNetInfo {
    fun getIpAndMacInfo(): List<Pair<String, String>> {
        val result = emptyList<Pair<String, String>>().toMutableList()
        kotlin.runCatching {
            for (networkInterface in NetworkInterface.getNetworkInterfaces()) {
                // 过滤 127. docker
                if (!networkInterface.isLoopback && networkInterface.displayName != "docker0") {
                    val mac = networkInterface.hardwareAddress.joinToString(
                        "-",
                        transform = {
                            Integer.toHexString(it.toInt() and 0xff)
                        }
                    )

                    for (inetAddress in networkInterface.inetAddresses) {
                        when (inetAddress) {
                            is Inet4Address -> {
                                result += mac to inetAddress.hostAddress
                            }
                        }
                    }
                }
            }
        }
        return result.toMutableList()
    }
}
