package com.timzaak.ucloud.mqtt

import com.typesafe.config.Config

data class MqttConfig(
    val productSN: String,
    val deviceSN: String,
    val devicePassword: String,
    val broker: String = "tcp://mqtt-cn-sh2.iot.ucloud.cn", // UCloud SH2
    val qos: Int = 1
) {
    val clientId: String = "$productSN.$deviceSN"
    val userName: String = "$productSN|$deviceSN|1"

    val topicPrefixPath: String = "/$productSN/$deviceSN/"

    companion object {
        fun fromConfig(conf: Config): MqttConfig {
            return MqttConfig(
                conf.getString("productSN"),
                conf.getString("deviceSN"),
                conf.getString("devicePassword")
            )
        }
    }
}
