package config

import com.typesafe.config.Config

class AppConfig(private val config: Config) {
    val storeId: String by lazy {
        config.getString("server.storeId")
    }
    val remoteServer: String by lazy {
        config.getString("api.remoteServer.host")
    }
    val serverCert: String by lazy {
        config.getString("api.remoteServer.cert")
    }
    val cardPayUrl: String by lazy {
        config.getString("pos.cardPayUrl")
    }
    val cardPayBusinessType: String by lazy {
        config.getString("pos.cardPayBusinessType")
    }
    val printCustomizedBusinessType: String by lazy {
        config.getString("pos.printCustomizedBusinessType")
    }
    val logPath: String by lazy {
        config.getString("server.logPath")
    }
    val environment: String by lazy {
        config.getString("server.environment")
    }
}
