package di

import com.mjitech.service.DownClientService
import com.mjitech.service.mqtt.CloudMqttService
import com.mjitech.third.down.DownUDPClient
import com.mjitech.third.down.mock.MockUDPDownServer
import com.mjitech.third.scancode.ScanCodeClient
import com.mjitech.third.scancode.mock.MockScanCodeServer
import io.ktor.application.*
import io.ktor.util.KtorExperimentalAPI
import mu.KotlinLogging
import org.koin.ktor.ext.inject

private val logger = KotlinLogging.logger { }
@KtorExperimentalAPI
fun Application.cleanServer() {
    val scanCodeClient : ScanCodeClient by inject()
    val mockUDPDownServer : MockUDPDownServer by inject()
    val downUDPClient : DownUDPClient by inject()
    val mockScanCodeServer : MockScanCodeServer by inject()


//    val applicationStopping = EventDefinition<Application>()
    val ApplicationStopPreparing = EventDefinition<ApplicationEnvironment>()
    val ApplicationStarted = EventDefinition<Application>()
    val app = ApplicationEvents()
    val handler = AddEventData()
    app.subscribe(ApplicationStarted,handler)

    fun toClean(){
        scanCodeClient.close()
        downUDPClient.close()
        mockUDPDownServer.close()
        mockScanCodeServer.close()
    }
}


class AddEventData : EventHandler<Application> {
    override fun invoke(p1: Application) {
        logger.info { "eventHandler" }
    }

}
