package routes

import com.mjitech.third.scancode.ScanCodeChannel
import com.mjitech.third.scancode.mock.MockScanCodeServer
import com.typesafe.config.Config
import config.isEnableMockScanCodeServer
import io.ktor.application.call
import io.ktor.http.HttpStatusCode
import io.ktor.response.respond
import io.ktor.routing.Route
import io.ktor.routing.get
import io.ktor.routing.route
import org.koin.ktor.ext.inject

// mock 服务的路由，方便测试
fun Route.mockRoute(config: Config) {

       // val mockScanCodeServer by inject<MockScanCodeServer>()
        val scanCodeChannel by inject<ScanCodeChannel>()
        route("/mock/scan_code/{scanCode}") {
            get {
                val scanCode = call.parameters["scanCode"]
                if (scanCode != null) {
                    scanCodeChannel.send(scanCode)
                    //mockScanCodeServer.sendMessage(scanCode)
                    call.respond(HttpStatusCode.OK)
                }
            }

    }
}
