package routes

import com.fasterxml.jackson.databind.JsonNode
import com.fasterxml.jackson.databind.ObjectMapper
import com.mjitech.compatible.toAttachmentAdapt
import com.mjitech.service.state.StateManager
import com.timzaak.jackson.jsObject
import com.timzaak.ws.ConnectionManager
import config.AppConfig
import io.ktor.http.cio.websocket.Frame
import io.ktor.http.cio.websocket.readText
import io.ktor.routing.Route
import io.ktor.websocket.DefaultWebSocketServerSession
import io.ktor.websocket.webSocket
import org.koin.ktor.ext.inject
import java.util.*

// 兼容老的, 应该被废弃掉
fun Route.websocketRoute(appConfig: AppConfig) {
    val connectionManager: ConnectionManager by inject()
    val objectManager: ObjectMapper by inject()
    val stateManager: StateManager by inject()

    suspend fun DefaultWebSocketServerSession.send(text: String) {
        outgoing.send(Frame.Text(text))
    }

    suspend fun DefaultWebSocketServerSession.send(json: JsonNode) {
        send(json.toString())
    }

    webSocket("/notify") {
        val sessionId = UUID.randomUUID().toString()
        connectionManager.memberJoin(sessionId, this)
        send(
            jsObject {
                "type" /= "GET_STORE_ID"
                "data" /= appConfig.storeId
            }.toString()
        )
        try {
            for (frame in incoming) {
                when (frame) {
                    is Frame.Text -> {
                        val text = frame.readText()
                        if (text != "pong") {
                            val json = objectManager.readTree(text)
                            when (json["type"].asText()) {
                                "WILL_CLOSEDOOR" -> {
                                    stateManager.downMachineState?.let {
                                        send(it.toAttachmentAdapt())
                                    }
                                }
                                else -> {
                                }
                            }
                        }
                    }
                    else -> {
                    }
                }
            }
        } finally {
            connectionManager.memberLeft(sessionId)
        }
    }
}
