package com.mjitech.qa.test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.CookieStore;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.testng.annotations.Test;

import com.mjitech.qa.service.BaseService;

import net.sf.json.JSONObject;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class FactoryPickUp_68 implements Runnable {
	BaseService service = new BaseService();
	JSONObject json = JSONObject.fromObject("{}");
	Map map = new HashMap();
	int mumber = 0 ;
	public FactoryPickUp_68(int mumber) {
		this.mumber = mumber ;
	}
	
	/**
	 * 登录
	 */
	@Test
	public void login() {
		CookieStore cookieStore = new BasicCookieStore();
		String loginUrl = "https://test.mjitech.com/web/login.action";
		CloseableHttpClient client = HttpClients.custom().setDefaultCookieStore(cookieStore).build();
		HttpPost httpPost = new HttpPost(loginUrl);
		JSONObject jsonParam = new JSONObject();
		jsonParam.put("username", "gangwang@mjitech.com");
		jsonParam.put("password", "yier34wu6");
		StringEntity entity = new StringEntity(jsonParam.toString(), "utf-8");
		entity.setContentEncoding("UTF-8");
		entity.setContentType("application/json");

		try {
			httpPost.setEntity(entity);
			HttpResponse httpResponse = client.execute(httpPost);
			String responseString = EntityUtils.toString(httpResponse.getEntity());
			if (httpResponse.getStatusLine().getStatusCode() == 200) {
				List<org.apache.http.cookie.Cookie> cookies = cookieStore.getCookies();
				if (CollectionUtils.isNotEmpty(cookies)) {
					for (org.apache.http.cookie.Cookie cookie : cookies) {
						// cookiesValues = cookie.getName() + "=" +
						// cookie.getValue()+";";
						System.out.println(cookie.getName() + "=" + cookie.getValue() + ";");
						map.put(cookie.getName(), cookie.getValue());
					}
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				// 关闭流并释放资源
				client.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}
	
	/**
	 * 批量测试-全门店抓取测试（不间断的每个品都抓测一遍）-物资学院01门店68-专项硬件测试 测试策略：每8个一出仓
	 */
	@Test(dependsOnMethods = "login")
	public void pickUpGoodsTest68() {
		String JSESSIONID = (String) map.get("JSESSIONID");
		String cookiesValues = "mjitech_username='gangwang@mjitech.com'" + ";ga=GA1.2.1640278628.1537349020;"
				+ "JSESSIONID=" + JSESSIONID;
		System.out.println("CookiesValues=" + cookiesValues);
		OkHttpClient client = new OkHttpClient();
		ArrayList<String> pass_id_list = null;

		boolean flag = true;
		int count = 0;
		while (flag) {
			pass_id_list = new ArrayList<String>();
			pass_id_list.add("141403");// 1-2-1
			pass_id_list.add("145216");// 1-2-6
			pass_id_list.add("141461");// 1-6-1
			pass_id_list.add("141460");// 1-6-5
			pass_id_list.add("141384");// 2-2-1
			pass_id_list.add("141383");// 2-2-7
			pass_id_list.add("141391");// 4-2-1
			pass_id_list.add("145215");// 4-2-6
			pass_id_list.add("141439");// 6-2-1
			pass_id_list.add("141444");// 6-2-8
			pass_id_list.add("141471");// 8-1-1
			pass_id_list.add("141474");// 8-1-7
			if (pass_id_list != null) {
				// 循环抓取次数
				for (int j = 0; j < mumber; j++) {
					// 控制货道商品输出
					for (int i = 0; i < pass_id_list.size(); i++) {
						count++;
						System.out.println("物资学院01-68门店开始第:<<----------" + count + "次抓测---------->>" + "--货道ID="
								+ pass_id_list.get(i));
						Request request = new Request.Builder()
								.url("https://test.mjitech.com/web/pick_up_goods/68/" + pass_id_list.get(i) + "")
								.get().addHeader("Cookie", cookiesValues).addHeader("cache-control", "no-cache")
								.addHeader("Postman-Token", "ee590a55-6c93-413b-b60b-21b4a88f38fe").build();
						try {
							Response response = client.newCall(request).execute();
							System.out.println("商品:" + pass_id_list.get(i) + "抓取结果：" + response);
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

						try {
							// 休眠30秒
						//	Thread.sleep(30000);
							Thread.sleep(1000);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

						// 判断每8个一出仓开门
						if (count % 8 == 0) {
							// 出仓，开门
							String url = "https://test.mjitech.com/web/open_goods_door?storeId=68";
							System.out.println("CookiesValues=" + cookiesValues);
							try {
								json = service.httpPostOpenGoodsDoorReturnJson(url, cookiesValues);
								System.out.println("出仓开门>>" + json);
							} catch (ClientProtocolException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}

							try {
								// 开舱门休眠40秒
							//	Thread.sleep(40000);
								Thread.sleep(1000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}

						}

					}
				}

			}

		}

	}
	
	public void run() {
		// TODO Auto-generated method stub
		this.login();
		this.pickUpGoodsTest68();
	}
}
