package com.mjitech.practice

import com.mjitech.third.down.entity.ACK
import com.mjitech.third.down.entity.OutGoods
import com.mjitech.third.down.entity.server.OutGoodStatus
import com.mjitech.third.down.protocol.DownDecoder
import com.mjitech.third.down.protocol.DownEncoder
import com.mjitech.third.down.protocol.getInt
import com.mjitech.third.down.protocol.inBytes
import com.mjitech.third.down.protocol.toHumanRead
import org.junit.Test

class SerializationTest {
    val ack = ACK(1, 2.toByte(), 3, 4)

    @Test
    fun testOne() {
        val selfEncoder = DownEncoder(ACK.type)

        ACK.serializer().serialize(selfEncoder, ack)
        val b = ack::class.supertypes

//        val (frameNumber,frame) = commandToFrame(ack)
//        println(frame.toHumanRead())
        val a = ByteArray(4)
//        println(frameNumber.inBytes(a,0))
        println(a.toHumanRead())

        println("======")
        println(selfEncoder.getData().toHumanRead())
//        println(frameNumber.inBytes(a,0))
        println(a.toHumanRead())

        val downDecoder = DownDecoder(selfEncoder.getData())

        val ack2 = ACK.serializer().deserialize(downDecoder)
        assert(ack == ack2)

        // println(ack2)
    }
    @Test
    fun testIntSe() {
        val a = ByteArray(4)
        1.inBytes(a, 0)
        println(a.getInt(0))
    }

    @Test
    fun testOutGood() {
//        val a = OutGoods(shelfNumber=2, x=435, y=810, x1=31, y1=0, number=1, action=1)
//        println(a.toBytes().second.toHumanRead())
//        [7d, 7e, 1e, 5f, 45, b, 36, 1, 2, 0, 0, 1, b3, 0, 0, 3, 2a, 0, 0, 0, 1f, 0, 0, 0, 0, 1, 1, f7, d, a]
        // 7d, 7e, 1e, 25, be, 86,3a,1, 02 00 00 01 b3 00 00 03 2a 00 00 00 1f 00 00 00 00 01 01 39 0d 0a
    }

    @Test
    fun testOutGoodStatus() {
        val a = 0xef.toUByte().toInt() and 0xff
        val b = 0xef.toByte().toInt() and 0xff
        println(b)
        println(a)
//        println(OutGoodStatus(100, 0.toByte(), 0x11.toByte()).toBytes().second.toHumanRead())
    }
}
