package com.mjitech.service.state

import com.mjitech.api.model.Order
import com.mjitech.api.model.OrderBatch
import com.mjitech.api.model.SKU
import com.mjitech.service.ShopService
import helper.shopServiceDI
import kotlinx.coroutines.channels.consumeEach
import kotlinx.coroutines.launch
import kotlinx.coroutines.runBlocking
import org.junit.Rule
import org.junit.Test
import org.koin.test.KoinTest
import org.koin.test.inject

class StateManagerTest : KoinTest {

    val stateManager: StateManager by inject()
    val shopService: ShopService by inject()
//    val config = ConfigFactory.load()
//    val appConfig = AppConfig(config)
//    val httpClient = HttpClient(Apache) {
//        install(Logging) {
//            logger = Logger.DEFAULT
//            level = LogLevel.ALL
//        }
//    }
//    val baseAPIImpl = BaseAPIImpl(
//        appConfig, httpClient, coroutineContext
//    )
//
//    @get:Rule
//    val rul = module(createdAtStart = true) {
//        single { config }
//        single { coroutineContext }
//        single { appConfig }
//        single { httpClient }
//        single { baseAPIImpl }
//    }
    @get:Rule
    val rule = shopServiceDI()

    @Test
    fun `can enter error state`() {
        val sku1 = SKU(
            listOf(), "", 1, 1, 1, 1, 1, 1,
            false, 1, 1, "1", "1", 1, 1, 1, 1,
            1, 1, 1, 1
        )
        val sku2 = SKU(
            listOf(), "", 2, 2, 2, 2, 2, 2,
            true, 2, 2, "2", "2", 2, 2, 2, 2,
            2, 2, 2, 2
        )
        val sku3 = SKU(
            listOf(), "", 3, 3, 3, 3, 3, 3,
            false, 3, 3, "3", "3", 3, 3, 3, 3,
            3, 3, 3, 3
        )
        val batch = OrderBatch(
            1,
            mutableListOf(sku1, sku2, sku3),
            1, 1, 1, 1, 1, 1, 1, 1
        )
        val order = Order(
            mutableListOf(batch),
            "123456",
            1
        )
        runBlocking {
            launch() {
                listOf(
                    shopService
                ).forEach { service ->
                    stateManager.subscribe().consumeEach { service.consume(it) }
                }
            }
        }
    }
}
