package com.mjitech.third.down

import com.mjitech.service.state.entity.Event
import com.mjitech.third.down.entity.*
import com.mjitech.third.down.entity.server.HeartBeatResponse
import com.mjitech.third.down.entity.server.OutGoodDoorStatus
import com.mjitech.third.down.entity.server.OutGoodStatus
import com.mjitech.third.down.protocol.toHumanRead
import helper.downUdpRule
import kotlinx.coroutines.channels.consumeEach
import kotlinx.coroutines.launch
import mu.KLogger
import mu.KotlinLogging
import org.junit.Rule
import org.junit.Test
import org.koin.test.KoinTest
import org.koin.test.inject

class SimpleClientTest : KoinTest {
    @get:Rule
    val rule = downUdpRule()

     val logger: KLogger = KotlinLogging.logger { }

    private val downClient: DownClient by inject()

    @Test
    fun downOutGoods() {
        downClient.downClientChannel.launch {
            downClient.downClientChannel.channel.openSubscription().consumeEach { message ->
                when(message) {
                    is OutGoodStatus -> {

//                        if(Integer.valueOf("0x"+message.status.toHumanRead())<11){
//                            println("===================${message.status}")
//                        }
                        when (message.status) {
                            OutGoodStatus.Companion.Status.IS_TAKING -> {
                            }
                            OutGoodStatus.Companion.Status.PRODUCT_REMAIN -> {
                            }
                            OutGoodStatus.Companion.Status.TakeGoodMiss -> {
                            }
                            OutGoodStatus.Companion.Status.TakeSingleGood -> {
                                println("message status : 8")
                                downClient.sendCommand(OutGoodDoor)
//                                Thread.sleep(1000)
//                                downClient.sendCommand(ResetSCM)
                            }
                            OutGoodStatus.Companion.Status.READY -> {
                            }
                            OutGoodStatus.Companion.Status.MachineError -> {
                                logger.info { "MachineError....." }
                                downClient.sendCommand(MachineError)
                            }
                            else -> {
                                logger.debug { "do not handle OutGoodStatus:${message.status.toHumanRead()}" }
                            }
                        }
                    }
                    is OutGoodDoorStatus -> {
                        when (message.status) {
                            OutGoodDoorStatus.opening -> {
                                println("opening_____")
                            }
                            OutGoodDoorStatus.openSuccess -> {
                                println("openSuccess____")
                            }
                            else -> {}
                        }
                    }
                    else -> {}
                }

            }
        }

        downClient.sendCommand(ResetSCM)
        Thread.sleep(5000)
        downClient.sendCommand(HeartBeatRequest)
        Thread.sleep(1000)
//        downClient.sendCommand(OutGoods(1.toByte(),300,200,80,60,1,1))
//        downClient.sendCommand(OutGoods(2.toByte(),438,279,20,60,1,1))
        var a = 0
        while(true) {
            downClient.sendCommand(HeartBeatRequest)
            Thread.sleep(100)
            a++
        }

    }

    @Test
    fun testOpenDoor(){
        downClient.downClientChannel.launch {
            downClient.downClientChannel.channel.openSubscription().consumeEach { message ->
               println(message)
            }
        }

//        downClient.sendCommand(OutGoodDoor)
        downClient.sendCommand(ResetMachine)
//        downClient.sendCommand(ResetSCM)

        Thread.sleep(5*1000)

        var a = 0
        while(a< 100) {
            downClient.sendCommand(HeartBeatRequest)
            Thread.sleep(800)
            a++
        }
    }

    @Test
    fun testOpenADoor(){
        downClient.downClientChannel.launch {
            downClient.downClientChannel.channel.openSubscription().consumeEach { message ->
                println("openDoor____message:"+message)
            }
        }

        //downClient.sendCommand(StorageDoor(StorageDoor.OpenDoor,StorageDoor.AreaB))
        downClient.sendCommand(StorageDoor(StorageDoor.OpenDoor,StorageDoor.AreaA))
        var a = 0
        while(a< 100) {
            // downClient.sendCommand(HeartBeatRequest)
            Thread.sleep(1*1000)
            a++
        }
    }

}
