package com.mjitech.third.scancode

import com.mjitech.third.scancode.mock.MockScanCodeServer
import helper.scanCodeClientRule
import kotlinx.coroutines.channels.consumeEach
import kotlinx.coroutines.launch
import kotlinx.coroutines.runBlocking
import org.junit.Rule
import org.junit.Test
import org.koin.test.KoinTest
import org.koin.test.inject
import kotlin.coroutines.CoroutineContext

class ScanCodeClientTest : KoinTest {

    @get:Rule
    val rule = scanCodeClientRule()

    private val scanCodeClient: ScanCodeClient by inject()
    private val mockScanCodeServer: MockScanCodeServer by inject()
    private val coroutineContext: CoroutineContext by inject()

    @Test
    fun simpleOne() {
        runBlocking {
            launch(coroutineContext) {
                scanCodeClient.scanCodeChannel.channel.consumeEach { it ->
                    println("come here: $it")
                }
            }
            launch {
                mockScanCodeServer.sendMessage("Hello World")
            }
        }
    }
}
